////////////////////////////////////////////////////////////////////////////////
// 
// SendVia 
// by DoubleSix
//
// This file is distributed under the terms of the GNU General Public License
// version 2.
//
////////////////////////////////////////////////////////////////////////////////

if (!doublesix) var doublesix = {};

if (!doublesix.sendvia)
    doublesix.sendvia = {};

doublesix.sendvia.strBundle = null;

doublesix.sendvia.localize = function (str) {
    if (!doublesix.sendvia.strBundle)
        doublesix.sendvia.strBundle = document.getElementById("doublesix.sendvia.locale");
    return doublesix.sendvia.strBundle.getString(str);
};

doublesix.sendvia.status = function (str) {
    textId = "doublesix.sendvia.statusText";    
    try {
        statusText = document.getElementById(textId);
        if (statusText)
            statusText.setAttribute("label", str);
    } catch (ex) {
        document.getElementById("statusText").setAttribute("label", str)
    }
};

doublesix.sendvia.newMenuItem = function (id, type, value, label, checked,
                                          tooltiptext, oncommand) {
    var menuitem = document.createElementNS
    ("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
     "menuitem");
    menuitem.setAttribute("id", id);
    if (type) {
        menuitem.setAttribute("type", type);
        if (type == "checkbox")
            menuitem.setAttribute("checked", checked);
    };
    if (value) menuitem.setAttribute("value", value);
    menuitem.setAttribute("label", label);
    menuitem.setAttribute("tooltiptext", tooltiptext);
    menuitem.setAttribute("oncommand", oncommand);
    return menuitem;
};

// Restoring values for stmp servers
doublesix.sendvia.noRestore = function () { };
doublesix.sendvia.restore = function () { };
doublesix.sendvia.restoreConfig = function () { };

doublesix.sendvia.resetToDefault = function () {
    doublesix.sendvia.restore();
    doublesix.sendvia.restore = doublesix.sendvia.noRestore;
    doublesix.sendvia.status("SendVia");
};

doublesix.sendvia.newServer = function () {
    var args = {server: null, result: false, addSmtpServer: ""};
    window.openDialog("chrome://messenger/content/SmtpServerEdit.xul",
                      "smtpEdit", "chrome,titlebar,modal,centerscreen", args);
    // temporarily disable sending
    if (!gWindowLocked) {
        gWindowLocked = true;
        doublesix.sendvia.restore = function() { gWindowLocked = false; };
    }
    return;
};

doublesix.sendvia.about = function () {
    window.openDialog("chrome://sendvia/content/about.xul",
                      "SendVia", 'chrome,modal,resizable');
    if (!gWindowLocked) {
        gWindowLocked = true;
        doublesix.sendvia.restore = function() { gWindowLocked = false; };
    }
    return;
};

doublesix.sendvia.newSmtpMenuItem = function () {
    return doublesix.sendvia.newMenuItem("SmtpMenuItem" // id
                            , null // type
                            , null // value
                            , doublesix.sendvia.localize("NewSMTPServerLabel") // label
                            , false // checked
                            , doublesix.sendvia.localize("NewSMTPServerTooltip") // tooltiptext
                            , "doublesix.sendvia.newServer();" // oncommand
                            );
};

doublesix.sendvia.aboutMenuItem = function () {
    return doublesix.sendvia.newMenuItem("SmtpMenuItem" // id
                            , null // type
                            , null // value
                            , doublesix.sendvia.localize("AboutLabel") // label
                            , false // checked
                            , doublesix.sendvia.localize("AboutTooltip") // tooltiptext
                            , "doublesix.sendvia.about();" // oncommand
                            );
};

// Compare SMTP servers
doublesix.sendvia.compareServers = function (s1,s2) {
    var sd1 = s1.description;
    var sd2 = s2.description;
    return ((sd1 < sd2) ? -1 : ((sd1 > sd2) ? 1 : 0));
};

doublesix.sendvia.buildMenu = function () {
    if (Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService).offline) {
        return;
    }
    dump("SendVia: building menu");
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"]
                                .getService(Components.interfaces.nsISmtpService);
    var myIdKey = doublesix.sendvia.getCurrentIdentityKey();
    var mySmtpServerPref = "mail.identity." + myIdKey + ".smtpServer";
    var myPrefs = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefBranch);
    var myDefaultSmtpKey = smtpService.defaultServer.key;
    var mySmtpKey;
    
    var myIdSmtpKey = null;
    try {
        var myIdSmtpKey = myPrefs.getCharPref(mySmtpServerPref);
    } catch (ex) { // Fails when default SMTP server is used
    };
    
    // Computing restore functions
    if (myIdSmtpKey) {
        mySmtpKey = myIdSmtpKey;
        doublesix.sendvia.restoreConfig = function () {
            myPrefs.setCharPref(mySmtpServerPref, myIdSmtpKey);
            doublesix.sendvia.status("SMTP("+myIdKey+") <- "
                        + smtpService.getServerByKey(myIdSmtpKey).hostname);
        };
    } else  {
        mySmtpKey = myDefaultSmtpKey;
        doublesix.sendvia.restoreConfig = function () {
            smtpService.defaultServer = smtpService.getServerByKey(myDefaultSmtpKey);
            doublesix.sendvia.status("SMTP <- " + smtpService.defaultServer.hostname);
        };
    }
    
    var smtpMenu = document.getElementById("doublesix.sendvia.menu");
    var sendMsg = "via ";
    
    var servers = smtpService.smtpServers;
    // Remove servers associated to deleted accounts?
    var sortedServers = new Array();
    var nbServers = 0;
    try {
        nbServers = servers.Count(); // Fails if tb 3.x
        dump("SendVia: We are in TB2.x");
        for (var i = 0; i < nbServers; ++i) {
            sortedServers[i] = servers.
                QueryElementAt(i, Components.interfaces.nsISmtpServer);
        }
    }
    catch (err) { // No Count method, servers is probably a nsISimpleEnumerator
        dump("SendVia: We are in TB3.x");
        while (servers.hasMoreElements()) {
            sortedServers[nbServers] =
                servers.getNext().QueryInterface(Components.interfaces.nsISmtpServer);
            nbServers++;
        }
    }
            
    sortedServers.sort(doublesix.sendvia.compareServers);
            
    // Choices, current is checked
    for (var i = 0; i < nbServers; ++i) {
        var server = sortedServers[i];
        var baloon = sendMsg + server.hostname;
        if (server.port) baloon += (":" + server.port);
        if (server.username) baloon += (" [" + server.username + "]");
        smtpMenu.appendChild
            (doublesix.sendvia.newMenuItem
             ("SmtpMenuItem", "checkbox", server.key,
              ((server.description) ? sendMsg + server.description : baloon),
              (server.key == mySmtpKey),
              baloon,
              "doublesix.sendvia.selected(this);"));
    }
    // --------------------------------------------------------
    smtpMenu.appendChild
    (document.createElementNS
     ("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
      "menuseparator"));
    // Declare new SMTP server
    smtpMenu.appendChild(doublesix.sendvia.newSmtpMenuItem());
    // --------------------------------------------------------
    smtpMenu.appendChild
    (document.createElementNS
     ("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
      "menuseparator"));
    // About sendvia
    smtpMenu.appendChild(doublesix.sendvia.aboutMenuItem());
};

doublesix.sendvia.getCurrentIdentityKey = function () {
    var identityList = document.getElementById("msgIdentity");
    var accountKey = identityList.selectedItem.getAttribute("accountkey");
    return identityList.value;
};

doublesix.sendvia.selected = function (selectedKey) {
    // See wether there is a preferred SMTP server for this identity
    var myIdKey = doublesix.sendvia.getCurrentIdentityKey();
    var mySmtpServerPref = "mail.identity." + myIdKey + ".smtpServer";
    var myPrefs = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefBranch);
    var myIdSmtpKey = null;
    try {
        var myIdSmtpKey = myPrefs.getCharPref(mySmtpServerPref);
    } catch (ex) { // Fails when default SMTP server is used
    };
    
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"]
    .getService(Components.interfaces.nsISmtpService);
            
    var selectedServer = smtpService.getServerByKey(selectedKey.value);
    doublesix.sendvia.status("Via " + selectedServer.hostname);
            
    if (myIdSmtpKey) {
        // There is a server associated to the current identity:
        // modify its value.
        myPrefs.setCharPref(mySmtpServerPref, selectedKey.value);
    } else {
        // No specific server: we must change the default server.
        if (selectedKey != smtpService.defaultServer.key)
            smtpService.defaultServer = selectedServer;
    }
    doublesix.sendvia.restore = doublesix.sendvia.restoreConfig;
};

doublesix.sendvia.clearMenu = function () {
    var smtpMenu = document.getElementById('doublesix.sendvia.menu');
    while (smtpMenu.hasChildNodes())
        smtpMenu.removeChild(smtpMenu.firstChild);
    // restore in 2s, so that sending use modified config.
    setTimeout(doublesix.sendvia.resetToDefault, 2000);
};

doublesix.sendvia.showMenu = function () {
    var smtpMenu = document.getElementById('doublesix.sendvia.menu');
    smtpMenu.showPopup();
    return true;
};
